import java.io.*;
import java.util.*;

public class cross_ma {
    String fileName = "";

    char[][] a;
    int[][] pref;
    int n, m;

    boolean isSq(int i, int j, int s) {
        return !(i < 0 || j < 0 || i + s > n || j + s > m) && pref[i + s][j + s] - pref[i][j + s] - pref[i + s][j] + pref[i][j] == s * s;
    }

    boolean isCross(int x, int y, int s) {
        return isSq(x, y, s) &&
                isSq(x + s, y, s) &&
                isSq(x - s, y, s) &&
                isSq(x, y + s, s) &&
                isSq(x, y - s, s);
    }

    public void solve() throws IOException {
        n = nextInt();
        m = nextInt();
        a = new char[n][m];
        for (int i = 0; i < n; i++) {
            a[i] = nextToken().toCharArray();
        }
        pref = new int[n + 1][m + 1];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                pref[i + 1][j + 1] = pref[i][j + 1] + pref[i + 1][j] - pref[i][j];
                if (a[i][j] == '#') {
                    pref[i + 1][j + 1]++;
                }
            }
        }

        int mx = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                while (isCross(i, j, mx + 1)) {
                    mx++;
                }
            }
        }

        out.println(mx);
    }

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new cross_ma().run();
    }

}