#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;
vector<string> a;

bool check_sq(int x, int y, int s) {
	for (int i = 0; i < s; i++) {
		for (int j = 0; j < s; j++) {
			if (x + i < 0 || y + j < 0 || x + i >= n || y + j >= m || a[x + i][y + j] != '#') {
				return false;
			}
		}
	}

	return true;
}

bool check_cross(int x, int y, int s) {
	return check_sq(x, y, s) &&
		   check_sq(x - s, y, s) &&
		   check_sq(x + s, y, s) &&
		   check_sq(x, y - s, s) &&
		   check_sq(x, y + s, s);
}

int main() {
#ifdef DEBUG
	freopen("input", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	int mx = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int s = 0; s <= n && s <= m; s++) {
				if (check_cross(i, j, s)) {
					mx = max(mx, s);
				}
			}
		}
	}

	cout << mx << endl;

	return 0;
}