#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 2000;
int n, m;
int a[MAXN][MAXN];
bool used[MAXN][MAXN];
int dx[] = {-1, 1, 0, 0};
int dy[] = {0, 0, -1, 1};

bool dfs(int x, int y) {
    used[x][y] = true;
    for (int d = 0; d < 4; d++) {
        int xx = x + dx[d], yy = y + dy[d];
        if (xx < 0 || xx >= n || yy < 0 || yy >= m) {
            return true;
        } else if (!used[xx][yy] && a[xx][yy] == 1) {
            if (dfs(xx, yy)) {
                return true;
            }
        }
    }
    return false;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 1) {
                for (int x = 0; x < n; x++) {
                    fill(used[x], used[x] + m, false);
                }

                if (!dfs(i, j)) {
                    ans++;
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}
