import java.io.*;
import java.util.*;

public class water_ma_java {
    String fileName = "";

    final int INF = 2000000000;
    final int[] dx = {0, 0, -1, 1};
    final int[] dy = {-1, 1, 0, 0};

    long pack(long d, int x, int y) {
        return (d << 30) + (x << 15) + y;
    }

    int getd(long mask) {
        return (int) (mask >> 30);
    }

    int getx(long mask) {
        return (int) ((mask >> 15) & ((1 << 15) - 1));
    }

    int gety(long mask) {
        return (int) (mask & ((1 << 15) - 1));
    }

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[][] h = new int[n][m];
        int[][] dst = new int[n][m];
        TreeSet<Long> st = new TreeSet<>();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                h[i][j] = nextInt();

                if (i == 0 || i == n - 1 || j == 0 || j == m - 1) {
                    dst[i][j] = h[i][j];
                    st.add(pack(h[i][j], i, j));
                } else {
                    dst[i][j] = INF;
                }
            }
        }
        while (!st.isEmpty()) {
            long um = st.first();
            st.pollFirst();
            int x = getx(um), y = gety(um), dd = getd(um);
            for (int d = 0; d < 4; d++) {
                int xx = x + dx[d], yy = y + dy[d];
                if (0 <= xx && xx < n && 0 <= yy && yy < m) {
                    int w = Math.max(dd, h[xx][yy]);
                    if (w < dst[xx][yy]) {
                        st.remove(pack(dst[xx][yy], xx, yy));
                        dst[xx][yy] = w;
                        st.add(pack(dst[xx][yy], xx, yy));
                    }
                }
            }
        }

        long ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                ans += dst[i][j] - h[i][j];
            }
        }

        out.println(ans);
    }

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new water_ma_java().run();
    }

}